﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography.X509Certificates;
using Microsoft.IdentityModel.Configuration;
using TestWorkflowService;
using Microsoft.IdentityModel.Tokens;
using System.ServiceModel.Security;
using System.IdentityModel.Selectors;
using Microsoft.IdentityModel.Protocols.WSTrust;
using System.ServiceModel;
using Microsoft.IdentityModel.SecurityTokenService;

namespace BasicSTS
{
    class Program
    {
        static void Main(string[] args)
        {
            X509Certificate2 pfx = new X509Certificate2("localhost.pfx", "a");

            SecurityTokenServiceConfiguration stsConfig =
                new SecurityTokenServiceConfiguration("urn:localhost", new X509SigningCredentials(pfx))
                {
                    SecurityTokenService = typeof(CustomSecurityTokenService),
                };

            // host STS as WS-Trust endpoint.
            WSTrustServiceHost stsHost = new WSTrustServiceHost(stsConfig, new Uri("http://localhost:9000/STS"));
            var bid = new WSHttpBinding("AnnonyForCertificate");
            stsHost.AddServiceEndpoint(typeof(IWSTrustFeb2005SyncContract), bid,"" );
            stsHost.Credentials.ServiceCertificate.Certificate = pfx;
            stsHost.Open();

            Console.WriteLine("STS running...");
            foreach (var ep in stsHost.Description.Endpoints)
            {
                Console.WriteLine(ep.ListenUri);
            }
            Console.ReadLine();
            stsHost.Close();
        }
    }
}
