﻿using System;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Channels;


[ServiceContract]
interface IPingService
{
    [OperationContract]
    void Ping();
}

class PingService : IPingService
{
    public void Ping()
    {
        var remote = OperationContext.Current.IncomingMessageProperties[RemoteEndpointMessageProperty.Name] as RemoteEndpointMessageProperty;
        Console.WriteLine("Ping from {0}:{1}", remote.Address, remote.Port);

        if (OperationContext.Current.ServiceSecurityContext != null &&
            OperationContext.Current.ServiceSecurityContext.AuthorizationContext != null &&
            OperationContext.Current.ServiceSecurityContext.AuthorizationContext.ClaimSets != null)
        {
            Console.WriteLine("Claims");
            Console.WriteLine("======");
            foreach (var cs in OperationContext.Current.ServiceSecurityContext.AuthorizationContext.ClaimSets)
            {
                foreach (var claim in cs)
                {
                    Console.WriteLine("ClaimType = {0}, Value ={1}", claim.ClaimType.Split('/').Last(), claim.Resource);
                }
            }
        }


    }
}