﻿using System;
using System.IdentityModel.Selectors;
using System.Security.Cryptography.X509Certificates;
using System.ServiceModel;
using System.ServiceModel.Security;

namespace WCFService
{
    class Program
    {
        static void Main(string[] args)
        {
            var sh = new ServiceHost(typeof(PingService));
            sh.Credentials.ServiceCertificate.Certificate = new X509Certificate2("localhost.pfx", "a");

            //Only use this mode in testing.
            sh.Credentials.IssuedTokenAuthentication.CertificateValidationMode = X509CertificateValidationMode.None;
            sh.Open();
            Console.WriteLine("Host ready. Endpoints: ");

            foreach(var ep in sh.Description.Endpoints)
                Console.WriteLine(ep.ListenUri);
            Console.ReadLine();
            sh.Close();
        }
    }

    public class SimpleUserNamePasswordValidator : UserNamePasswordValidator
    {
        public override void Validate(string userName, string password)
        {
            Console.WriteLine("[Success]: {0} authenticated.", userName);
        }
    }

}
