﻿using System;
using System.IdentityModel.Selectors;
using System.Security.Cryptography.X509Certificates;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Security;

//Standard Code Based WCF Service.
namespace WCFService
{
    class Program
    {
        static void Main(string[] args)
        {
            var sh = new ServiceHost(typeof(PingService));
            sh.Credentials.ServiceCertificate.Certificate = new X509Certificate2("localhost.pfx", "a");
            sh.Credentials.UserNameAuthentication.CustomUserNamePasswordValidator = new SimpleUserNamePasswordValidator();
            sh.Credentials.UserNameAuthentication.UserNamePasswordValidationMode = UserNamePasswordValidationMode.Custom;

            sh.Open();
            Console.WriteLine("Host ready. Endpoints: ");
            foreach (var ep in sh.Description.Endpoints)
                Console.WriteLine(ep.ListenUri);
            Console.ReadLine();
            sh.Close();
        }
    }

    public class SimpleUserNamePasswordValidator : UserNamePasswordValidator
    {
        public override void Validate(string userName, string password)
        {
            Console.WriteLine("[Success]: {0} authenticated.", userName);
        }
    }

    

    [ServiceContract]
    class PingService
    {
        [OperationContract]
        public void Ping()
        {
            var remoteEndpoint = OperationContext.Current.IncomingMessageProperties[RemoteEndpointMessageProperty.Name] as RemoteEndpointMessageProperty;
            Console.WriteLine("Ping from {0}:{1}", remoteEndpoint.Address, remoteEndpoint.Port);
        }
    }
}
